#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
reload(sys)
sys.setdefaultencoding('utf8')
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from systembutton import CleanButton


class BottomWidget(QWidget):

    m_parent = None
    ordinary_tristate_status = 2
    important_tristate_status = 2
    ordinary_or_important = False
    click_ordinary_main_cb = pyqtSignal(int)
    click_important_main_cb = pyqtSignal(int)

    def __init__(self, parent = None):
        super(BottomWidget,self).__init__(parent)
        self.m_parent = parent
        self.setGeometry(0, 141, 500, 459)
        self.init_ui()
        self.init_style_sheet()
        self.init_text()

    def init_ui(self):
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(234,240,243))
        self.setPalette(palette)

        self.label_ordinary = QLabel()
        self.label_important = QLabel()
        self.label_description = QLabel()

        self.btn_arrow_ordinary = QPushButton(self)
        self.btn_arrow_important = QPushButton(self)
        self.btn_arrow_ordinary.setFocusPolicy(Qt.NoFocus)
        self.btn_arrow_important.setFocusPolicy(Qt.NoFocus)
        self.btn_arrow_ordinary.setFixedSize(16,16)
        self.btn_arrow_important.setFixedSize(16,16)
        self.btn_arrow_ordinary.setIcon(QIcon("./res/up.png"))
        self.btn_arrow_important.setIcon(QIcon("./res/down.png"))
        self.btn_arrow_ordinary.hide()
        self.btn_arrow_important.hide()

        self.cb_ordinary = CleanButton(self)
        self.cb_ordinary.setCheckboxStatus(2)
        self.cb_ordinary.setFocusPolicy(Qt.NoFocus)
        self.cb_ordinary.hide()

        self.cb_important = CleanButton(self)
        self.cb_important.setCheckboxStatus(2)
        self.cb_important.setFocusPolicy(Qt.NoFocus)
        self.cb_important.hide()

        self.btn_arrow_ordinary.clicked.connect(self.slot_click_arrow_btn)
        self.btn_arrow_important.clicked.connect(self.slot_click_arrow_btn)
        self.cb_ordinary.clicked.connect(self.slot_click_ordinary_cb)
        self.cb_important.clicked.connect(self.slot_click_important_cb)

        layout_h_cb_o = QHBoxLayout()
        layout_h_cb_o.addWidget(self.cb_ordinary)
        layout_h_cb_o.addWidget(self.label_ordinary)
        layout_h_cb_o.addStretch()
        layout_h_cb_o.addWidget(self.btn_arrow_ordinary)
        layout_h_cb_o.setSpacing(8)
        layout_h_cb_o.setMargin(0)
        layout_h_cb_o.setContentsMargins(0, 0, 20, 0)

        layout_h_cb_i = QHBoxLayout()
        layout_h_cb_i.addWidget(self.cb_important)
        layout_h_cb_i.addWidget(self.label_important)
        layout_h_cb_i.addStretch()
        layout_h_cb_i.addWidget(self.btn_arrow_important)
        layout_h_cb_i.setSpacing(8)
        layout_h_cb_i.setMargin(0)
        layout_h_cb_i.setContentsMargins(0, 0, 20, 0)

        self.lw_ordinary = QListWidget()
        self.lw_ordinary.setFocusPolicy(Qt.NoFocus)
        self.lw_ordinary.setSpacing(1)
        self.lw_ordinary.setFixedSize(461, 214)

        self.lw_important = QListWidget()
        self.lw_important.setFocusPolicy(Qt.NoFocus)
        self.lw_important.setSpacing(1)
        self.lw_important.setFixedSize(461, 214)

        self.te_description = QTextEdit()
        self.te_description.setReadOnly(True)
        self.te_description.setFixedWidth(461)

        layout_main = QVBoxLayout()
        layout_main.addLayout(layout_h_cb_o)
        layout_main.addWidget(self.lw_ordinary)
        layout_main.addLayout(layout_h_cb_i)
        layout_main.addWidget(self.lw_important)
        layout_main.addWidget(self.label_description)
        layout_main.addWidget(self.te_description)
        layout_main.setSpacing(10)
        layout_main.setContentsMargins(20, 10, 0, 10)
        self.setLayout(layout_main)

    def init_style_sheet(self):
        self.label_ordinary.setStyleSheet("QLabel{color:#666666;font-size:13px;}")
        self.label_important.setStyleSheet("QLabel{color:#666666;font-size:13px;}")
        self.btn_arrow_ordinary.setStyleSheet("QPushButton{background:transparent;}")
        self.btn_arrow_important.setStyleSheet("QPushButton{background:transparent;}")
        self.label_description.setStyleSheet("QLabel{color:#666666;font-size:13px;}")
        self.te_description.setStyleSheet("QTextEdit{background-color:#ffffff; border:1px solid #aaaaaa;font-size:13px;color:#666666;}")
        self.lw_ordinary.setStyleSheet("QListWidget{background-color:white;border:1px solid #aaaaaa;}QListWidget::item{height:34;margin-top:0px;border:0px;}QListWidget::item:hover{background:#c8e6ff;}QListWidget::item:selected{background:#e1f0f7;}")
        self.lw_ordinary.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
             QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:1px solid red;height:13px}\
             QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:blue;height:13px}\
             QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
             QScrollBar::handle:vertical{background-color:#D1D0D2;width:6px;} QScrollBar::handle:vertical:hover{background-color:#14ACF5;width:6px;}  QScrollBar::handle:vertical:pressed{background-color:#0B95D7;width:6px;}\
             QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
             QScrollBar::down-arrow:vertical{background-color:yellow;}\
             QScrollBar::add-line:vertical{subcontrol-origin:margin;border:1px solid green;height:13px}")
        self.lw_important.setStyleSheet("QListWidget{background-color:white;border:1px solid #aaaaaa;}QListWidget::item{height:34;margin-top:0px;border:0px;}QListWidget::item:hover{background:#c8e6ff;}QListWidget::item:selected{background:#e1f0f7;}")
        self.lw_important.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
             QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:1px solid red;height:13px}\
             QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:blue;height:13px}\
             QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
             QScrollBar::handle:vertical{background-color:#D1D0D2;width:6px;} QScrollBar::handle:vertical:hover{background-color:#14ACF5;width:6px;}  QScrollBar::handle:vertical:pressed{background-color:#0B95D7;width:6px;}\
             QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
             QScrollBar::down-arrow:vertical{background-color:yellow;}\
             QScrollBar::add-line:vertical{subcontrol-origin:margin;border:1px solid green;height:13px}")
        self.te_description.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
                                                             QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:1px solid red;height:13px}\
                                                             QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:blue;height:13px}\
                                                             QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                             QScrollBar::handle:vertical{background-color:#D1D0D2;width:6px;} QScrollBar::handle:vertical:hover{background-color:#14ACF5;width:6px;}  QScrollBar::handle:vertical:pressed{background-color:#0B95D7;width:6px;}\
                                                             QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                             QScrollBar::down-arrow:vertical{background-color:yellow;}\
                                                             QScrollBar::add-line:vertical{subcontrol-origin:margin;border:1px solid green;height:13px}")

    def init_text(self):
        self.label_ordinary.setText("普通更新详情：")
        self.label_important.setText("重要更新详情：")
        self.label_description.setText("更新描述：")

    def show_both_title(self):
        self.ordinary_or_important = True
        self.btn_arrow_ordinary.show()
        self.btn_arrow_important.show()
        self.btn_arrow_ordinary.setIcon(QIcon("./res/down.png"))
        self.btn_arrow_important.setIcon(QIcon("./res/up.png"))

        self.cb_ordinary.show()
        self.label_ordinary.show()
        self.lw_ordinary.hide()

        self.cb_important.show()
        self.label_important.show()
        self.lw_important.show()

    def show_ordinary_title(self):
        self.cb_ordinary.show()
        self.label_ordinary.show()
        self.lw_ordinary.show()
        self.cb_important.hide()
        self.label_important.hide()
        self.lw_important.hide()

    def show_important_title(self):
        self.cb_important.show()
        self.label_important.show()
        self.lw_important.show()
        self.cb_ordinary.hide()
        self.label_ordinary.hide()
        self.lw_ordinary.hide()

    def switch_title(self, status):
        self.m_parent.change_description_content(status)
        if status:
            self.cb_important.show()
            self.label_important.show()
            self.lw_important.show()
            self.cb_ordinary.show()
            self.label_ordinary.show()
            self.lw_ordinary.hide()
        else:
            self.cb_ordinary.show()
            self.label_ordinary.show()
            self.lw_ordinary.show()
            self.cb_important.show()
            self.label_important.show()
            self.lw_important.hide()

    def slot_click_arrow_btn(self):
        if self.ordinary_or_important:
            self.ordinary_or_important = False
            self.switch_title(False)
            self.btn_arrow_ordinary.setIcon(QIcon("./res/up.png"))
            self.btn_arrow_important.setIcon(QIcon("./res/down.png"))
        else:
            self.ordinary_or_important = True
            self.switch_title(True)
            self.btn_arrow_ordinary.setIcon(QIcon("./res/down.png"))
            self.btn_arrow_important.setIcon(QIcon("./res/up.png"))

    def slot_click_ordinary_cb(self):
        if self.ordinary_tristate_status == 0:
            self.ordinary_tristate_status = 2
            self.cb_ordinary.setCheckboxStatus(2)
            self.click_ordinary_main_cb.emit(2)
        elif self.ordinary_tristate_status == 1:
            self.ordinary_tristate_status = 2
            self.cb_ordinary.setCheckboxStatus(2)
            self.click_ordinary_main_cb.emit(2)
        elif self.ordinary_tristate_status == 2:
            self.ordinary_tristate_status = 0
            self.cb_ordinary.setCheckboxStatus(0)
            self.click_ordinary_main_cb.emit(0)

    def slot_click_important_cb(self):
        if self.important_tristate_status == 0:
            self.important_tristate_status = 2
            self.cb_important.setCheckboxStatus(2)
            self.click_important_main_cb.emit(2)
        elif self.important_tristate_status == 1:
            self.important_tristate_status = 2
            self.cb_important.setCheckboxStatus(2)
            self.click_important_main_cb.emit(2)
        elif self.important_tristate_status == 2:
            self.important_tristate_status = 0
            self.cb_important.setCheckboxStatus(0)
            self.click_important_main_cb.emit(0)