#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = 'lixiang'

from PyQt4.QtGui import *
from PyQt4.QtCore import *
from titlebar import TitleBar


class LoadingWidget(QWidget):

    m_parent = None

    def __init__(self, parent = None):
        super(LoadingWidget,self).__init__(parent)
        self.m_parent = parent
        self.setGeometry(0, 0, 336, 100)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(234,240,243))#eaf0f3
        self.setPalette(palette)

        self.title_bar = TitleBar(self.width(), False, "麒麟软件更新器", self)
        self.title_bar.move(0,0)
        self.title_bar.show()

        self.init_ui()
        self.init_style_sheet()
        self.init_text()

    def init_ui(self):
        self.tiplabel = QLabel(self)
        self.tiplabel.setGeometry(QRect(10,40,316,17))
        self.errorlabel = QLabel(self)
        self.errorlabel.setAlignment(Qt.AlignCenter)
        self.errorlabel.setGeometry(QRect(10,60,316,17))
        self.errorlabel.hide()
        self.progressBar = QProgressBar(self)
        self.progressBar.setGeometry(QRect(10,65,316,19))
        self.progressBar.setValue(0)

        self.loadingmove = QMovie("./res/loading1.gif")
        self.loadinglabel = QLabel(self)
        self.loadinglabel.setGeometry(QRect(40,65,256,20))
        self.loadinglabel.setMovie(self.loadingmove)
        self.loadingmove.start()
        self.loadinglabel.hide()

    def init_style_sheet(self):
        self.tiplabel.setStyleSheet("QLabel{color:#666666;font-size:13px;}")
        self.errorlabel.setStyleSheet("QLabel{color:#666666;font-size:13px;text-align:center;}")
        self.progressBar.setStyleSheet("QProgressBar{background-color:#ffffff;border:1px solid #aaaaaa;border-radius:0px;color:#666666;text-align:center;}"
                                          "QProgressBar:chunk{background-color:#7acfff;}")
    def init_text(self):
        self.tiplabel.setText("正在配置软件管理服务dpkg...")