#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = 'lixiang'

from PyQt4.QtGui import *
from PyQt4.QtCore import *
from systembutton import SystemButton


class TitleBar(QWidget):

    minTitleBar = SIGNAL("minTitleBar")
    closeTitleBar = SIGNAL("closeTitleBar")

    def __init__(self, width, has_btn_min, title = "", parent=None):
        super(TitleBar, self).__init__(parent)

        self.setFixedSize(width, 30)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAutoFillBackground(True)

        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(15,132,188))     # 0f84bc
        self.setPalette(palette)

        self.min_button = SystemButton(self)
        if has_btn_min:
            self.min_button.show()
        else:
            self.min_button.hide()
        self.close_button = SystemButton(self)

        self.logo_label = QLabel()
        self.logo_label.setFixedSize(22, 22)
        self.logo_label.setFrameShape(QFrame.NoFrame)
        self.logo_label.setAutoFillBackground(True)
        self.logo_label.setScaledContents(True)
        self.label_pixmap = QPixmap("./res/icon.png")
        self.logo_label.setPixmap(self.label_pixmap)

        self.title_label = QLabel()
        self.title_label.setStyleSheet("QLabel{color:#ffffff;font-size:13px;}")
        self.title_label.setText(title)

        self.min_button.loadPixmap("./res/min_button.png")
        self.close_button.loadPixmap("./res/close_button.png")

        hlayout = QHBoxLayout()
        hlayout.addWidget(self.logo_label, 0, Qt.AlignVCenter)
        hlayout.addWidget(self.title_label, 0, Qt.AlignVCenter)
        hlayout.setSpacing(5)
        hlayout.setContentsMargins(5, 0, 0, 0)


        main_layout = QHBoxLayout()
        main_layout.addLayout(hlayout)
        main_layout.addStretch()
        main_layout.addWidget(self.min_button, 0, Qt.AlignTop)
        main_layout.addWidget(self.close_button, 0, Qt.AlignTop)
        main_layout.setSpacing(0)
        main_layout.setContentsMargins(0, 0, 0, 0)

        self.setLayout(main_layout)


if __name__ == '__main__':
    import sys
    app = QApplication(sys.argv)
    title = TitleBar(280, True)
    title.show()
    sys.exit(app.exec_())