#!/usr/bin/python
# -*- coding: utf-8 -*-

ICON_PATH = "/usr/share/ubuntu-kylin-software-center/data/icons/"


class UPackage:

    package = None
    displayName = None

    def __init__(self, pkg):
        self.package = pkg

    @property
    def name(self):
        return self.package.name

    @property
    def fullname(self):
        return self.package.fullname

    @property
    def icon(self):
        return ICON_PATH + self.name + ".png"

    @property
    def description(self):
        return self.package.candidate.description

    @property
    def summary(self):
       return self.package.candidate.summary

    @property
    def downloadSize(self):
        try:
            return self.package.candidate.size
        except:
            return 0

    @property
    def downloadSizeHuman(self):
        size = self.downloadSize
        sizek = size / 1024
        if(sizek <= 1):
            return "1 KB"
        elif(sizek > 1 and sizek < 1024):
            return str(sizek) + " KB"
        else:
            return str('%.2f' % (sizek / 1024.0)) + " MB"

    @property
    def installedSize(self):
        try:
            return self.package.candidate.installed_size
        except:
            return 0

    @property
    def installedSizeHuman(self):
        size = self.installedSize
        sizek = size / 1024
        if(sizek <= 1):
            return "1 KB"
        elif(sizek > 1 and sizek < 1024):
            return str(sizek) + " KB"
        else:
            return str('%.2f' % (sizek / 1024.0)) + " MB"

    @property
    def installedVersion(self):
        if(self.package.installed is not None):
            return self.package.installed.version
        else:
            return " "

    @property
    def candidateVersion(self):
        try:
            return self.package.candidate.version
        except:
            return " "