#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys
reload(sys)
sys.setdefaultencoding('utf8')

import dbus
import dbus.service
from dbus.mainloop.glib import DBusGMainLoop
mainloop = DBusGMainLoop(set_as_default=True)

from kylindbus.daemon import Daemon
from utils.enums import INTERFACE, INTERFACES, Signals
import signal
import dbus.mainloop.glib
from gi.repository import GObject
from PyQt4.QtCore import *


class DbusService(QObject):

    dbusDaemon = None

    def __init__(self):
        QObject.__init__(self)

        print "正在启动dbus服务..."
        self.init_dbus()

    def exit_dbus(self):
        self.dbusDaemon.exit()

    def init_dbus(self):
        try:
            bus = dbus.SystemBus(mainloop)
        except:
            print "无法初始化dbus..."
            sys.exit(0)

        # dbus已经在运行，直接获取
        try:
            dbusObj = bus.get_object(INTERFACE, INTERFACES, INTERFACE)
            self.dbusDaemon = dbus.Interface(dbusObj, INTERFACE)

            self.dbusDaemon.connect_to_signal("kum_fetch_signal", self.slot_kum_fetch_signal)
            self.dbusDaemon.connect_to_signal("kum_apt_signal", self.slot_kum_apt_signal)

        # dbus还未运行，启动一个新的
        except dbus.DBusException:
            os.environ["TERM"] = "xterm"
            os.environ["PATH"] = "/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/X11R6/bin"
            os.environ["DEBIAN_FRONTEND"] = "noninteractive"
            if os.path.exists("/var/lib/apt/lists/lock"):
                os.remove("/var/lib/apt/lists/lock")
            dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
            GObject.threads_init()
            signal.signal(signal.SIGINT, lambda : mainloop.quit())
            self.dbusDaemon = Daemon(dbus.SystemBus(), mainloop)
            self.dbusDaemon.connect_to_signal("kum_fetch_signal", self.slot_kum_fetch_signal)
            self.dbusDaemon.connect_to_signal("kum_apt_signal", self.slot_kum_apt_signal)
            mainloop.run()

    def call_update_source(self):
        self.dbusDaemon.update(False)

    def call_update_source_by_shell(self):
        self.dbusDaemon.update_by_shell(False)

    def call_configure_dpkg_by_shell(self):
        self.dbusDaemon.configure_dpkg_by_shell(False)

    def call_install_and_upgrade(self, pkgNames):
        self.dbusDaemon.install_and_upgrade(pkgNames)

    def call_install_pkgs(self, pkgNames):
        self.dbusDaemon.install(pkgNames)

    def call_insone(self, pkgName):
        self.dbusDaemon.insone(pkgName)

    def call_upgrade_pkgs(self, pkgNames):
        self.dbusDaemon.upgrade(pkgNames)

    def call_upone(self, pkgName):
        self.dbusDaemon.upone(pkgName)

    def change_source_list_to_default(self, service_key, pwd, current_user, os_codename, available_source):
        self.dbusDaemon.change_source_list_to_default(service_key, pwd, current_user, os_codename, available_source)

    def change_source_list_to_kylin_update(self, lines):
        self.dbusDaemon.change_source_list_to_kylin_update_server(lines)

    def slot_kum_fetch_signal(self, processtype, kwarg):
        signalType = "fetch"
        appName = kwarg['download_appname']
        percent = float(kwarg['download_percent'])
        action = kwarg['action']
        processType = processtype

        if (processType == "down_pulse"):
            processType = processType + " 共" + str(int(kwarg['total_bytes'])/1024) + "KB，已下载" + str(int(kwarg['download_bytes'])/1024) + "KB，总个数为" + str(int(kwarg['total_items'])) + "个，正在下载第" + str(int(kwarg['download_items'])) + "个"

        if (processType == "down_cancel"):
            signalType = "cancel"
            percent = -1

        self.emit(Signals.dbus_process_msg, signalType, appName, action, percent, processType, '')

    def slot_kum_apt_signal(self, processtype, kwarg):
        signalType = "apt"
        appName = kwarg['apt_appname']
        percent = float(kwarg['apt_percent'])
        action = kwarg['action']
        processType = processtype
        status = ""
        if(processtype == "status_change"):
            status = kwarg['status']
        self.emit(Signals.dbus_process_msg, signalType, appName, action, percent, processType, status)