#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
reload(sys)
sys.setdefaultencoding('utf8')
from PyQt4.QtCore import QThread
from PyQt4.QtCore import pyqtSignal
from service.db_service import DBService
from model.upackage import UPackage
from utils.enums import Signals, AppType, AptFunc
import locale
import apt
import time
import threading


class AccessThread(QThread):

    accessOver = pyqtSignal(long, long, int, int, list)
    oneAppMsg = pyqtSignal(dict)

    work_list = []
    iname_list = []
    cname_list = []

    db = None
    ca = None
    mutex = None

    def __init__(self, iname_list, cname_list, parent=None):
        QThread.__init__(self)

        locale.setlocale(locale.LC_ALL, "zh_CN.UTF-8")
        self.iname_list = iname_list
        self.cname_list = cname_list
        self.mutex = threading.RLock()
        self.db = DBService()

    # 初始化apt cache，如不在线程中执行则会卡住主线程
    def init_apt_cache(self):
        self.ca = apt.Cache()

    # 获取kylin-update-*包
    def get_kylin_update_pkg(self):
        ku_list = []
        kum = None

        self.ca.open()
        for pkg in self.ca:
            if(pkg.name == "kylin-update-desktop" or pkg.name == "kylin-update-server"):
                ku_list.append(pkg)
            if(pkg.name == "kylin-update-manager"):
                kum = pkg

        self.emit(Signals.get_kylin_update_over, ku_list, kum)

    # 获取更新信息
    def get_all_update(self):
        ordinary_list = []
        important_list = []
        crucial_list = []
        size_byte_ordinary = 0
        size_byte_important = 0

        self.ca.open()

        for pkg in self.ca:
            # 关键升级
            if(pkg.name in self.cname_list):
                if(pkg.is_installed == False or pkg.is_upgradable == True):
                    crucial_list.append(pkg.name)
            # 重要升级
            elif(pkg.name in self.iname_list):
                if(pkg.is_installed == False or pkg.is_upgradable == True):
                    upkg = UPackage(pkg)
                    self.fill_info_cn(upkg)
                    important_list.append(upkg)
                    size_byte_important += upkg.downloadSize
                    self.oneAppMsg.emit({"apptype":AppType.IMPORTANT, "displayName":upkg.displayName, "name":upkg.name, "icon":upkg.icon, "downloadSizeHuman":upkg.downloadSizeHuman, "downloadSize":upkg.downloadSize, "installedVersion":upkg.installedVersion, "candidateVersion":upkg.candidateVersion, "description":upkg.description})
                    # 避免ui卡顿
                    time.sleep(0.05)
            # 普通升级
            else:
                pass

        self.accessOver.emit(size_byte_ordinary, size_byte_important, len(ordinary_list), len(important_list), crucial_list)

    # 填充中文信息
    def fill_info_cn(self, upkg):
        displayNameCN = self.db.get_display_name_cn_by_name(upkg.name)
        if(displayNameCN != "" and displayNameCN != " " and displayNameCN != "None" and displayNameCN != None):
            upkg.displayName = displayNameCN

        descriptionCN = self.db.get_description_by_name(upkg.name)
        if(descriptionCN != "" and descriptionCN != " " and descriptionCN != "None" and descriptionCN != None):
            upkg.description = descriptionCN

    def run(self):

        while(True):
            if len(self.work_list) == 0:
                time.sleep(0.2)
                continue

            self.mutex.acquire()
            item = self.work_list.pop(0)
            self.mutex.release()

            if(item == AptFunc.INIT):
                self.init_apt_cache()
            elif(item == AptFunc.GET_KYLIN_UPDATE):
                self.get_kylin_update_pkg()
            elif(item == AptFunc.GET_ALL_UPDATE):
                self.get_all_update()

            time.sleep(0.2)