#!/usr/bin/python
# -*- coding: utf-8 -*-
__author__ = "huangsheng"

import os, sys
reload(sys)
sys.setdefaultencoding('utf8')
from PyQt4.QtCore import QSettings
from hashlib import md5
import time
import getpass


class CommonUtils:

    os_codename = ""

    # 将byte转换成更可读的格式
    def byte_human(self, size_byte):
        if(size_byte == 0):
            return "0"
        else:
            sizek = size_byte / 1024
            if(sizek <= 1):
                size_str = "1 KB"
            elif(sizek > 1 and sizek < 1024):
                size_str = str(sizek) + " KB"
            else:
                size_str = str('%.2f' % (sizek / 1024.0)) + " MB"
            return size_str

    # 计算md5值
    def md5sum(self, text):
        m = md5()
        m.update(text)
        return m.hexdigest()

    # 获取当前用户
    def get_current_user(self):
        return getpass.getuser()

    # 当前系统是桌面版还是服务器版
    def desktop_or_server(self):
        settings = QSettings("/etc/.kyinfo", QSettings.IniFormat)
        settings.beginGroup("dist")
        data = str(settings.value("dist_id").toString()).strip()
        settings.endGroup()

        if(data.find("server") != -1):
            return "server"
        else:
            return "desktop"

    # 获取服务序列号
    def get_service_key(self):
        if os.path.exists("/etc/.kyinfo"):
            settings = QSettings("/etc/.kyinfo", QSettings.IniFormat)
            settings.beginGroup("servicekey")
            data = str(settings.value("key").toString()).strip()
            settings.endGroup()
            return data
        else:
            return None

    # 生成互联网软件源默认密码
    def get_hash_pwd(self):
        return self.md5sum("tianjinkylin")

    # 获取系统版本号
    def get_os_version(self):
        version = ""
        cmd_out = os.popen("lsb_release -r").readlines()
        for line in cmd_out:
            if(line.startswith("Release:")):
                version = line.split("\t")[1].strip()
                version = version[version.find('-')+1:] #wenbo 20160624
        return version.upper()

    # 获取系统版本标志
    def get_os_codename(self):
        if self.os_codename == "":
            cmd_out = os.popen("lsb_release -c").readlines()
            for line in cmd_out:
                if(line.startswith("Codename:")):
                    self.os_codename = line.split("\t")[1].strip()

        return self.os_codename

    # 获取系统文件记录的最后一次apt-get update成功的时间
    def get_last_update_success_stamp_by_file(self):
        f = "/var/lib/apt/periodic/update-success-stamp"

        if(os.path.exists(f)):
            time_str = time.ctime(os.path.getmtime(f))
            return time.strptime(time_str, "%a %b %d %H:%M:%S %Y")
        else:
            return time.strptime("1990-01-01 00:00:00", "%Y-%m-%d %H:%M:%S")

    # 约定格式的日期字符串转time
    def convert_str_to_time(self, time_str):
        return time.strptime(time_str, "%Y-%m-%d %H:%M:%S")


def main():
    cu = CommonUtils()
    print cu.get_service_key()
    # print cu.get_hash_pwd()
    # print cu.get_os_version()
    # print cu.get_os_codename()
    # print cu.get_last_update_success_stamp_by_file()
    # print cu.convert_str_to_time("2016-04-20 16:48:17")

    # strrr = "2016-04-20 16:48:17"
    # s2 = time.strptime(strrr, "%Y-%m-%d %H:%M:%S")
    # print type(s2), time.strftime("%Y-%m-%d %H:%M:%S", s2)


if __name__ == '__main__':
    main()